﻿package {
	import flash.display.MovieClip;
	import flash.events.Event;
	import flash.net.URLLoader;
	import flash.net.URLRequest;
	import com.greensock.TweenMax;
	import com.greensock.events.TweenEvent;
	
	public class Main extends MovieClip {
		
		private var xmlLoader:URLLoader; //this will load the xml
		private var xml:XML; //this will contain the xml data loaded by the xmlLoader
		private var gauges:Array; //this will store the created gauges
		
		public function Main():void {
			gauges = new Array(); //start the array
			xmlLoader = new URLLoader(); //start the loader
			xmlLoader.addEventListener(Event.COMPLETE,updateGauges) //when completes calls for a gauge update
			xmlLoader.load(new URLRequest("gauge.xml")); //initiates the xml call
			
		}
			
		private function updateGauges(e:Event):void {
			//populates the xml with the received data
			xml = new XML(e.target.data);
			
			//iterates through the gauges inside the xml structure
			var ln:int = xml.gauge.length();
			var i:int = 0
			
			while (i < ln) {
				gauges[i] = new Gauge(); //creates a new Gauge
				gauges[i].label_txt.text = xml.gauge[i].description[0].toUpperCase(); //adds the description to the label
				gauges[i].value_txt.text = "0%" //starts the gauge meter value
				//animates the gauge rotation (286 is the maximum rotation of the wheel we built)
				var tm:TweenMax = new TweenMax(gauges[i].needle_mc, 2, { rotation:Math.round(xml.gauge[i].value[0] *286 / 100) } );
				//this event is activated when the tween value changes, we do this to update the value text according to the needle position
				tm.addEventListener(TweenEvent.UPDATE, onTween)
				//y positioning
				gauges[i].y = 45
				//x positioning (220 pixels of distance between them and 50 pixels offset from the left margin
				gauges[i].x = (i * 220) + 50
				//adds to stage
				addChild(gauges[i]);
				//increases i for the next iteration
				i++
			}
		}
		
		private function onTween(e:Event):void {
			/*this will prevent a well known rotation bug inside flash 
			 * where, when rotating, after it reaches 180º it starts to count backwards
			 * negative ex: 0 to 180,-180 to 0, by adding 360 to the equation when the rotation is negative
			 * we can make sure the value is rightfully proportioned.
			 * */
			if (e.target.target.rotation < 0) {
				e.target.target.parent.value_txt.text = (Math.round( (360+e.target.target.rotation) * 100 / 286) + "%");
			}else{
				e.target.target.parent.value_txt.text = (Math.round( e.target.target.rotation * 100 / 286) + "%");
			}
		}
	}
}